package b4a.example;


import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "b4a.example", "b4a.example.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
        processBA.runHook("oncreate", this, null);
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
        WaitForLayout wl = new WaitForLayout();
        if (anywheresoftware.b4a.objects.ServiceHelper.StarterHelper.startFromActivity(processBA, wl, false))
		    BA.handler.postDelayed(wl, 5);

	}
	static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "b4a.example", "b4a.example.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "b4a.example.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
        try {
            if (processBA.subExists("activity_actionbarhomeclick")) {
                Class.forName("android.app.ActionBar").getMethod("setHomeButtonEnabled", boolean.class).invoke(
                    getClass().getMethod("getActionBar").invoke(this), true);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        if (processBA.runHook("oncreateoptionsmenu", this, new Object[] {menu}))
            return true;
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
        
		return true;
	}   
 @Override
 public boolean onOptionsItemSelected(android.view.MenuItem item) {
    if (item.getItemId() == 16908332) {
        processBA.raiseEvent(null, "activity_actionbarhomeclick");
        return true;
    }
    else
        return super.onOptionsItemSelected(item); 
}
@Override
 public boolean onPrepareOptionsMenu(android.view.Menu menu) {
    super.onPrepareOptionsMenu(menu);
    processBA.runHook("onprepareoptionsmenu", this, new Object[] {menu});
    return true;
    
 }
 protected void onStart() {
    super.onStart();
    processBA.runHook("onstart", this, null);
}
 protected void onStop() {
    super.onStop();
    processBA.runHook("onstop", this, null);
}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
        super.onNewIntent(intent);
		this.setIntent(intent);
        processBA.runHook("onnewintent", this, new Object[] {intent});
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        processBA.runHook("onpause", this, null);
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
        processBA.runHook("ondestroy", this, null);
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
        processBA.runHook("onresume", this, null);
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
        processBA.runHook("onactivityresult", this, new Object[] {requestCode, resultCode});
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public static String _clientid = "";
public static String _clientsecret = "";
public static String _authorizationcode = "";
public static String _accesstoken = "";
public static String _userinfolink = "";
public anywheresoftware.b4a.objects.ButtonWrapper _button1 = null;
public anywheresoftware.b4a.samples.httputils2.httputils2service _httputils2service = null;
public b4a.example.starter _starter = null;

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}
public static String  _activity_create(boolean _firsttime) throws Exception{
 //BA.debugLineNum = 32;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 34;BA.debugLine="Activity.LoadLayout(\"1\")";
mostCurrent._activity.LoadLayout("1",mostCurrent.activityBA);
 //BA.debugLineNum = 36;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 //BA.debugLineNum = 42;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
 //BA.debugLineNum = 44;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
 //BA.debugLineNum = 38;BA.debugLine="Sub Activity_Resume";
 //BA.debugLineNum = 40;BA.debugLine="End Sub";
return "";
}
public static String  _button1_click() throws Exception{
String _scope = "";
anywheresoftware.b4a.objects.WebViewWrapper _wv = null;
 //BA.debugLineNum = 47;BA.debugLine="Sub Button1_Click";
 //BA.debugLineNum = 48;BA.debugLine="If AuthorizationCode = \"\" Then";
if ((_authorizationcode).equals("")) { 
 //BA.debugLineNum = 49;BA.debugLine="Dim scope As String";
_scope = "";
 //BA.debugLineNum = 50;BA.debugLine="scope = \"email%20profile\"";
_scope = "email%20profile";
 //BA.debugLineNum = 51;BA.debugLine="Dim wv As WebView";
_wv = new anywheresoftware.b4a.objects.WebViewWrapper();
 //BA.debugLineNum = 52;BA.debugLine="wv.Initialize(\"wv\")";
_wv.Initialize(mostCurrent.activityBA,"wv");
 //BA.debugLineNum = 53;BA.debugLine="Activity.AddView(wv, 0, 0, 100%x, 100%y)";
mostCurrent._activity.AddView((android.view.View)(_wv.getObject()),(int) (0),(int) (0),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (100),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (100),mostCurrent.activityBA));
 //BA.debugLineNum = 54;BA.debugLine="wv.LoadUrl(\"https://accounts.google.com/o/oauth2";
_wv.LoadUrl("https://accounts.google.com/o/oauth2/auth?response_type=code&client_id="+_clientid+"&redirect_uri=urn:ietf:wg:oauth:2.0:oob&scope="+_scope);
 //BA.debugLineNum = 56;BA.debugLine="Button1.Enabled = False";
mostCurrent._button1.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 }else if((_accesstoken).equals("")) { 
 //BA.debugLineNum = 58;BA.debugLine="GetAccessToken";
_getaccesstoken();
 }else {
 //BA.debugLineNum = 60;BA.debugLine="RequestSignInDetails";
_requestsignindetails();
 };
 //BA.debugLineNum = 62;BA.debugLine="End Sub";
return "";
}
public static String  _getaccesstoken() throws Exception{
String _poststring1 = "";
anywheresoftware.b4a.samples.httputils2.httpjob _j = null;
 //BA.debugLineNum = 83;BA.debugLine="Sub GetAccessToken";
 //BA.debugLineNum = 85;BA.debugLine="ProgressDialogShow(\"Sending authentication reques";
anywheresoftware.b4a.keywords.Common.ProgressDialogShow(mostCurrent.activityBA,"Sending authentication request...");
 //BA.debugLineNum = 86;BA.debugLine="Dim postString1 As String";
_poststring1 = "";
 //BA.debugLineNum = 87;BA.debugLine="postString1 = \"code=\" & AuthorizationCode & \"&cli";
_poststring1 = "code="+_authorizationcode+"&client_id="+_clientid+"&client_secret="+_clientsecret+"&grant_type=authorization_code&redirect_uri=urn:ietf:wg:oauth:2.0:oob";
 //BA.debugLineNum = 90;BA.debugLine="Dim j As HttpJob";
_j = new anywheresoftware.b4a.samples.httputils2.httpjob();
 //BA.debugLineNum = 91;BA.debugLine="j.Initialize(\"GetAccessToken\", Me)";
_j._initialize(processBA,"GetAccessToken",main.getObject());
 //BA.debugLineNum = 92;BA.debugLine="j.PostString(\"https://accounts.google.com/o/oauth";
_j._poststring("https://accounts.google.com/o/oauth2/token",_poststring1);
 //BA.debugLineNum = 95;BA.debugLine="End Sub";
return "";
}
public static String  _globals() throws Exception{
 //BA.debugLineNum = 25;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 29;BA.debugLine="Private Button1 As Button";
mostCurrent._button1 = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 30;BA.debugLine="End Sub";
return "";
}
public static String  _jobdone(anywheresoftware.b4a.samples.httputils2.httpjob _job) throws Exception{
anywheresoftware.b4a.objects.collections.JSONParser _json = null;
anywheresoftware.b4a.objects.collections.Map _map1 = null;
 //BA.debugLineNum = 97;BA.debugLine="Sub JobDone(Job As HttpJob)";
 //BA.debugLineNum = 98;BA.debugLine="If Job.Success Then";
if (_job._success) { 
 //BA.debugLineNum = 99;BA.debugLine="Log(Job.GetString)";
anywheresoftware.b4a.keywords.Common.Log(_job._getstring());
 //BA.debugLineNum = 100;BA.debugLine="Select Job.JobName";
switch (BA.switchObjectToInt(_job._jobname,"GetAccessToken","getUserDetails")) {
case 0: {
 //BA.debugLineNum = 102;BA.debugLine="Dim JSON As JSONParser";
_json = new anywheresoftware.b4a.objects.collections.JSONParser();
 //BA.debugLineNum = 103;BA.debugLine="Dim map1 As Map";
_map1 = new anywheresoftware.b4a.objects.collections.Map();
 //BA.debugLineNum = 104;BA.debugLine="JSON.Initialize(Job.GetString)";
_json.Initialize(_job._getstring());
 //BA.debugLineNum = 105;BA.debugLine="map1=JSON.NextObject";
_map1 = _json.NextObject();
 //BA.debugLineNum = 106;BA.debugLine="AccessToken=map1.Get(\"access_token\")";
_accesstoken = BA.ObjectToString(_map1.Get((Object)("access_token")));
 //BA.debugLineNum = 107;BA.debugLine="ProgressDialogHide";
anywheresoftware.b4a.keywords.Common.ProgressDialogHide();
 //BA.debugLineNum = 108;BA.debugLine="RequestSignInDetails";
_requestsignindetails();
 break; }
case 1: {
 //BA.debugLineNum = 110;BA.debugLine="Msgbox(Job.GetString,\"We Got all details\")";
anywheresoftware.b4a.keywords.Common.Msgbox(_job._getstring(),"We Got all details",mostCurrent.activityBA);
 //BA.debugLineNum = 111;BA.debugLine="ProgressDialogHide";
anywheresoftware.b4a.keywords.Common.ProgressDialogHide();
 break; }
}
;
 }else {
 //BA.debugLineNum = 115;BA.debugLine="ToastMessageShow(\"Error sending request.\", True)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Error sending request.",anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 116;BA.debugLine="Log(Job.ErrorMessage)";
anywheresoftware.b4a.keywords.Common.Log(_job._errormessage);
 //BA.debugLineNum = 117;BA.debugLine="ProgressDialogHide";
anywheresoftware.b4a.keywords.Common.ProgressDialogHide();
 };
 //BA.debugLineNum = 119;BA.debugLine="Job.Release";
_job._release();
 //BA.debugLineNum = 120;BA.debugLine="End Sub";
return "";
}

public static void initializeProcessGlobals() {
    
    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        anywheresoftware.b4a.samples.httputils2.httputils2service._process_globals();
main._process_globals();
starter._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 15;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 18;BA.debugLine="Dim clientId As String : clientId = \"455700114482";
_clientid = "";
 //BA.debugLineNum = 18;BA.debugLine="Dim clientId As String : clientId = \"455700114482";
_clientid = "455700114482-8btlejaqrt18okvikbbolok7hqvudp54.apps.googleusercontent.com";
 //BA.debugLineNum = 19;BA.debugLine="Dim clientSecret As String : clientSecret = \"n8km";
_clientsecret = "";
 //BA.debugLineNum = 19;BA.debugLine="Dim clientSecret As String : clientSecret = \"n8km";
_clientsecret = "n8kmxGDFPL37hHijJRBn3Ya5";
 //BA.debugLineNum = 20;BA.debugLine="Dim AuthorizationCode, AccessToken As String";
_authorizationcode = "";
_accesstoken = "";
 //BA.debugLineNum = 21;BA.debugLine="Dim userInfoLink As String : userInfoLink = \"http";
_userinfolink = "";
 //BA.debugLineNum = 21;BA.debugLine="Dim userInfoLink As String : userInfoLink = \"http";
_userinfolink = "https://www.googleapis.com/oauth2/v1/userinfo";
 //BA.debugLineNum = 23;BA.debugLine="End Sub";
return "";
}
public static String  _requestsignindetails() throws Exception{
anywheresoftware.b4a.samples.httputils2.httpjob _j = null;
 //BA.debugLineNum = 122;BA.debugLine="Sub RequestSignInDetails";
 //BA.debugLineNum = 123;BA.debugLine="ProgressDialogShow(\"getting user info request...\"";
anywheresoftware.b4a.keywords.Common.ProgressDialogShow(mostCurrent.activityBA,"getting user info request...");
 //BA.debugLineNum = 124;BA.debugLine="Dim j As HttpJob";
_j = new anywheresoftware.b4a.samples.httputils2.httpjob();
 //BA.debugLineNum = 125;BA.debugLine="j.Initialize(\"getUserDetails\", Me)";
_j._initialize(processBA,"getUserDetails",main.getObject());
 //BA.debugLineNum = 126;BA.debugLine="j.Download2(userInfoLink, Array As String(\"access";
_j._download2(_userinfolink,new String[]{"access_token",_accesstoken});
 //BA.debugLineNum = 127;BA.debugLine="End Sub";
return "";
}
public static String  _wv_pagefinished(String _url) throws Exception{
anywheresoftware.b4a.objects.WebViewWrapper _wv = null;
thalmy.webviewxtended.xtender _w = null;
String _result = "";
 //BA.debugLineNum = 64;BA.debugLine="Sub wv_PageFinished (Url As String)";
 //BA.debugLineNum = 65;BA.debugLine="If Url.StartsWith(\"https://accounts.google.com/o/";
if (_url.startsWith("https://accounts.google.com/o/oauth2/approval")) { 
 //BA.debugLineNum = 66;BA.debugLine="Dim wv As WebView";
_wv = new anywheresoftware.b4a.objects.WebViewWrapper();
 //BA.debugLineNum = 67;BA.debugLine="wv = Sender";
_wv.setObject((android.webkit.WebView)(anywheresoftware.b4a.keywords.Common.Sender(mostCurrent.activityBA)));
 //BA.debugLineNum = 68;BA.debugLine="Dim w As WebViewXtender";
_w = new thalmy.webviewxtended.xtender();
 //BA.debugLineNum = 69;BA.debugLine="Dim result As String";
_result = "";
 //BA.debugLineNum = 70;BA.debugLine="result = w.getTitle(wv)";
_result = _w.getTitle((android.webkit.WebView)(_wv.getObject()));
 //BA.debugLineNum = 71;BA.debugLine="wv.RemoveView 'remove the WebView";
_wv.RemoveView();
 //BA.debugLineNum = 72;BA.debugLine="If result.StartsWith(\"Success code\") Then";
if (_result.startsWith("Success code")) { 
 //BA.debugLineNum = 73;BA.debugLine="AuthorizationCode = result.SubString(\"Success c";
_authorizationcode = _result.substring("Success code=".length());
 //BA.debugLineNum = 74;BA.debugLine="GetAccessToken";
_getaccesstoken();
 }else {
 //BA.debugLineNum = 76;BA.debugLine="Button1.Enabled = True";
mostCurrent._button1.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 77;BA.debugLine="Log(\"Error: \" & result)";
anywheresoftware.b4a.keywords.Common.Log("Error: "+_result);
 //BA.debugLineNum = 78;BA.debugLine="ToastMessageShow(result, True)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow(_result,anywheresoftware.b4a.keywords.Common.True);
 };
 };
 //BA.debugLineNum = 81;BA.debugLine="End Sub";
return "";
}
}
